t5[6-9]*: adjust the references to the default branch name "main"
[git] / t / test-lib.sh
1 # Test framework for git.  See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built.  The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22         # We allow tests to override this, in case they want to run tests
23         # outside of t/, e.g. for running tests on the test library
24         # itself.
25         TEST_DIRECTORY=$(pwd)
26 else
27         # ensure that TEST_DIRECTORY is an absolute path so that it
28         # is valid even if the current working directory is changed
29         TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
30 fi
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33         # Similarly, override this to store the test-results subdir
34         # elsewhere
35         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 fi
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
46
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
51
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53 then
54         echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55         exit 1
56 fi
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
59
60 # Disallow the use of abbreviated options in the test suite by default
61 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
62 then
63         GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
64         export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
65 fi
66
67 ################################################################
68 # It appears that people try to run tests without building...
69 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
70 if test $? != 1
71 then
72         if test -n "$GIT_TEST_INSTALLED"
73         then
74                 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
75         else
76                 echo >&2 'error: you do not seem to have built git yet.'
77         fi
78         exit 1
79 fi
80
81 store_arg_to=
82 opt_required_arg=
83 # $1: option string
84 # $2: name of the var where the arg will be stored
85 mark_option_requires_arg () {
86         if test -n "$opt_required_arg"
87         then
88                 echo "error: options that require args cannot be bundled" \
89                         "together: '$opt_required_arg' and '$1'" >&2
90                 exit 1
91         fi
92         opt_required_arg=$1
93         store_arg_to=$2
94 }
95
96 parse_option () {
97         local opt="$1"
98
99         case "$opt" in
100         -d|--d|--de|--deb|--debu|--debug)
101                 debug=t ;;
102         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
103                 immediate=t ;;
104         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
105                 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
106         -r)
107                 mark_option_requires_arg "$opt" run_list
108                 ;;
109         --run=*)
110                 run_list=${opt#--*=} ;;
111         -h|--h|--he|--hel|--help)
112                 help=t ;;
113         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
114                 verbose=t ;;
115         --verbose-only=*)
116                 verbose_only=${opt#--*=}
117                 ;;
118         -q|--q|--qu|--qui|--quie|--quiet)
119                 # Ignore --quiet under a TAP::Harness. Saying how many tests
120                 # passed without the ok/not ok details is always an error.
121                 test -z "$HARNESS_ACTIVE" && quiet=t ;;
122         --with-dashes)
123                 with_dashes=t ;;
124         --no-bin-wrappers)
125                 no_bin_wrappers=t ;;
126         --no-color)
127                 color= ;;
128         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
129                 valgrind=memcheck
130                 tee=t
131                 ;;
132         --valgrind=*)
133                 valgrind=${opt#--*=}
134                 tee=t
135                 ;;
136         --valgrind-only=*)
137                 valgrind_only=${opt#--*=}
138                 tee=t
139                 ;;
140         --tee)
141                 tee=t ;;
142         --root=*)
143                 root=${opt#--*=} ;;
144         --chain-lint)
145                 GIT_TEST_CHAIN_LINT=1 ;;
146         --no-chain-lint)
147                 GIT_TEST_CHAIN_LINT=0 ;;
148         -x)
149                 trace=t ;;
150         -V|--verbose-log)
151                 verbose_log=t
152                 tee=t
153                 ;;
154         --write-junit-xml)
155                 write_junit_xml=t
156                 ;;
157         --stress)
158                 stress=t ;;
159         --stress=*)
160                 echo "error: --stress does not accept an argument: '$opt'" >&2
161                 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
162                 exit 1
163                 ;;
164         --stress-jobs=*)
165                 stress=t;
166                 stress=${opt#--*=}
167                 case "$stress" in
168                 *[!0-9]*|0*|"")
169                         echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
170                         exit 1
171                         ;;
172                 *)      # Good.
173                         ;;
174                 esac
175                 ;;
176         --stress-limit=*)
177                 stress=t;
178                 stress_limit=${opt#--*=}
179                 case "$stress_limit" in
180                 *[!0-9]*|0*|"")
181                         echo "error: --stress-limit=<N> requires the number of repetitions" >&2
182                         exit 1
183                         ;;
184                 *)      # Good.
185                         ;;
186                 esac
187                 ;;
188         *)
189                 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
190         esac
191 }
192
193 # Parse options while taking care to leave $@ intact, so we will still
194 # have all the original command line options when executing the test
195 # script again for '--tee' and '--verbose-log' later.
196 for opt
197 do
198         if test -n "$store_arg_to"
199         then
200                 eval $store_arg_to=\$opt
201                 store_arg_to=
202                 opt_required_arg=
203                 continue
204         fi
205
206         case "$opt" in
207         --*|-?)
208                 parse_option "$opt" ;;
209         -?*)
210                 # bundled short options must be fed separately to parse_option
211                 opt=${opt#-}
212                 while test -n "$opt"
213                 do
214                         extra=${opt#?}
215                         this=${opt%$extra}
216                         opt=$extra
217                         parse_option "-$this"
218                 done
219                 ;;
220         *)
221                 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
222         esac
223 done
224 if test -n "$store_arg_to"
225 then
226         echo "error: $opt_required_arg requires an argument" >&2
227         exit 1
228 fi
229
230 if test -n "$valgrind_only"
231 then
232         test -z "$valgrind" && valgrind=memcheck
233         test -z "$verbose" && verbose_only="$valgrind_only"
234 elif test -n "$valgrind"
235 then
236         test -z "$verbose_log" && verbose=t
237 fi
238
239 if test -n "$stress"
240 then
241         verbose=t
242         trace=t
243         immediate=t
244 fi
245
246 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
247 TEST_NAME="$(basename "$0" .sh)"
248 TEST_NUMBER="${TEST_NAME%%-*}"
249 TEST_NUMBER="${TEST_NUMBER#t}"
250 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
251 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
252 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
253 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
254 case "$TRASH_DIRECTORY" in
255 /*) ;; # absolute path is good
256  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
257 esac
258
259 # If --stress was passed, run this test repeatedly in several parallel loops.
260 if test "$GIT_TEST_STRESS_STARTED" = "done"
261 then
262         : # Don't stress test again.
263 elif test -n "$stress"
264 then
265         if test "$stress" != t
266         then
267                 job_count=$stress
268         elif test -n "$GIT_TEST_STRESS_LOAD"
269         then
270                 job_count="$GIT_TEST_STRESS_LOAD"
271         elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
272              test -n "$job_count"
273         then
274                 job_count=$((2 * $job_count))
275         else
276                 job_count=8
277         fi
278
279         mkdir -p "$TEST_RESULTS_DIR"
280         stressfail="$TEST_RESULTS_BASE.stress-failed"
281         rm -f "$stressfail"
282
283         stress_exit=0
284         trap '
285                 kill $job_pids 2>/dev/null
286                 wait
287                 stress_exit=1
288         ' TERM INT HUP
289
290         job_pids=
291         job_nr=0
292         while test $job_nr -lt "$job_count"
293         do
294                 (
295                         GIT_TEST_STRESS_STARTED=done
296                         GIT_TEST_STRESS_JOB_NR=$job_nr
297                         export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
298
299                         trap '
300                                 kill $test_pid 2>/dev/null
301                                 wait
302                                 exit 1
303                         ' TERM INT
304
305                         cnt=1
306                         while ! test -e "$stressfail" &&
307                               { test -z "$stress_limit" ||
308                                 test $cnt -le $stress_limit ; }
309                         do
310                                 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
311                                 test_pid=$!
312
313                                 if wait $test_pid
314                                 then
315                                         printf "OK   %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
316                                 else
317                                         echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
318                                         printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
319                                 fi
320                                 cnt=$(($cnt + 1))
321                         done
322                 ) &
323                 job_pids="$job_pids $!"
324                 job_nr=$(($job_nr + 1))
325         done
326
327         wait
328
329         if test -f "$stressfail"
330         then
331                 stress_exit=1
332                 echo "Log(s) of failed test run(s):"
333                 for failed_job_nr in $(sort -n "$stressfail")
334                 do
335                         echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
336                         cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
337                 done
338                 rm -rf "$TRASH_DIRECTORY.stress-failed"
339                 # Move the last one.
340                 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
341         fi
342
343         exit $stress_exit
344 fi
345
346 # if --tee was passed, write the output not only to the terminal, but
347 # additionally to the file test-results/$BASENAME.out, too.
348 if test "$GIT_TEST_TEE_STARTED" = "done"
349 then
350         : # do not redirect again
351 elif test -n "$tee"
352 then
353         mkdir -p "$TEST_RESULTS_DIR"
354
355         # Make this filename available to the sub-process in case it is using
356         # --verbose-log.
357         GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
358         export GIT_TEST_TEE_OUTPUT_FILE
359
360         # Truncate before calling "tee -a" to get rid of the results
361         # from any previous runs.
362         >"$GIT_TEST_TEE_OUTPUT_FILE"
363
364         (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
365          echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
366         test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
367         exit
368 fi
369
370 if test -n "$trace" && test -n "$test_untraceable"
371 then
372         # '-x' tracing requested, but this test script can't be reliably
373         # traced, unless it is run with a Bash version supporting
374         # BASH_XTRACEFD (introduced in Bash v4.1).
375         #
376         # Perform this version check _after_ the test script was
377         # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
378         # '--verbose-log', so the right shell is checked and the
379         # warning is issued only once.
380         if test -n "$BASH_VERSION" && eval '
381              test ${BASH_VERSINFO[0]} -gt 4 || {
382                test ${BASH_VERSINFO[0]} -eq 4 &&
383                test ${BASH_VERSINFO[1]} -ge 1
384              }
385            '
386         then
387                 : Executed by a Bash version supporting BASH_XTRACEFD.  Good.
388         else
389                 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
390                 trace=
391         fi
392 fi
393 if test -n "$trace" && test -z "$verbose_log"
394 then
395         verbose=t
396 fi
397
398 # For repeatability, reset the environment to known value.
399 # TERM is sanitized below, after saving color control sequences.
400 LANG=C
401 LC_ALL=C
402 PAGER=cat
403 TZ=UTC
404 export LANG LC_ALL PAGER TZ
405 EDITOR=:
406
407 # GIT_TEST_GETTEXT_POISON should not influence git commands executed
408 # during initialization of test-lib and the test repo. Back it up,
409 # unset and then restore after initialization is finished.
410 if test -n "$GIT_TEST_GETTEXT_POISON"
411 then
412         GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
413         unset GIT_TEST_GETTEXT_POISON
414 fi
415
416 # A call to "unset" with no arguments causes at least Solaris 10
417 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
418 # deriving from the command substitution clustered with the other
419 # ones.
420 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
421         my @env = keys %ENV;
422         my $ok = join("|", qw(
423                 TRACE
424                 DEBUG
425                 TEST
426                 .*_TEST
427                 PROVE
428                 VALGRIND
429                 UNZIP
430                 PERF_
431                 CURL_VERBOSE
432                 TRACE_CURL
433         ));
434         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
435         print join("\n", @vars);
436 ')
437 unset XDG_CACHE_HOME
438 unset XDG_CONFIG_HOME
439 unset GITPERLLIB
440 TEST_AUTHOR_LOCALNAME=author
441 TEST_AUTHOR_DOMAIN=example.com
442 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
443 GIT_AUTHOR_NAME='A U Thor'
444 GIT_AUTHOR_DATE='1112354055 +0200'
445 TEST_COMMITTER_LOCALNAME=committer
446 TEST_COMMITTER_DOMAIN=example.com
447 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
448 GIT_COMMITTER_NAME='C O Mitter'
449 GIT_COMMITTER_DATE='1112354055 +0200'
450 GIT_MERGE_VERBOSITY=5
451 GIT_MERGE_AUTOEDIT=no
452 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
453 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
454 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
455 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
456 export EDITOR
457
458 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
459 export GIT_DEFAULT_HASH
460
461 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
462 GIT_TRACE_BARE=1
463 export GIT_TRACE_BARE
464
465 check_var_migration () {
466         # the warnings and hints given from this helper depends
467         # on end-user settings, which will disrupt the self-test
468         # done on the test framework itself.
469         case "$GIT_TEST_FRAMEWORK_SELFTEST" in
470         t)      return ;;
471         esac
472
473         old_name=$1 new_name=$2
474         eval "old_isset=\${${old_name}:+isset}"
475         eval "new_isset=\${${new_name}:+isset}"
476
477         case "$old_isset,$new_isset" in
478         isset,)
479                 echo >&2 "warning: $old_name is now $new_name"
480                 echo >&2 "hint: set $new_name too during the transition period"
481                 eval "$new_name=\$$old_name"
482                 ;;
483         isset,isset)
484                 # do this later
485                 # echo >&2 "warning: $old_name is now $new_name"
486                 # echo >&2 "hint: remove $old_name"
487                 ;;
488         esac
489 }
490
491 check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
492 check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
493 check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
494
495 # Use specific version of the index file format
496 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
497 then
498         GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
499         export GIT_INDEX_VERSION
500 fi
501
502 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
503 then
504         GIT_PERL_FATAL_WARNINGS=1
505         export GIT_PERL_FATAL_WARNINGS
506 fi
507
508 # Add libc MALLOC and MALLOC_PERTURB test
509 # only if we are not executing the test with valgrind
510 if test -n "$valgrind" ||
511    test -n "$TEST_NO_MALLOC_CHECK"
512 then
513         setup_malloc_check () {
514                 : nothing
515         }
516         teardown_malloc_check () {
517                 : nothing
518         }
519 else
520         setup_malloc_check () {
521                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
522                 export MALLOC_CHECK_ MALLOC_PERTURB_
523         }
524         teardown_malloc_check () {
525                 unset MALLOC_CHECK_ MALLOC_PERTURB_
526         }
527 fi
528
529 # Protect ourselves from common misconfiguration to export
530 # CDPATH into the environment
531 unset CDPATH
532
533 unset GREP_OPTIONS
534 unset UNZIP
535
536 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
537 1|2|true)
538         GIT_TRACE=4
539         ;;
540 esac
541
542 # Line feed
543 LF='
544 '
545
546 # Single quote
547 SQ=\'
548
549 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
550 # when case-folding filenames
551 u200c=$(printf '\342\200\214')
552
553 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
554
555 # Each test should start with something like this, after copyright notices:
556 #
557 # test_description='Description of this test...
558 # This test checks if command xyzzy does the right thing...
559 # '
560 # . ./test-lib.sh
561 test "x$TERM" != "xdumb" && (
562                 test -t 1 &&
563                 tput bold >/dev/null 2>&1 &&
564                 tput setaf 1 >/dev/null 2>&1 &&
565                 tput sgr0 >/dev/null 2>&1
566         ) &&
567         color=t
568
569 if test -n "$color"
570 then
571         # Save the color control sequences now rather than run tput
572         # each time say_color() is called.  This is done for two
573         # reasons:
574         #   * TERM will be changed to dumb
575         #   * HOME will be changed to a temporary directory and tput
576         #     might need to read ~/.terminfo from the original HOME
577         #     directory to get the control sequences
578         # Note:  This approach assumes the control sequences don't end
579         # in a newline for any terminal of interest (command
580         # substitutions strip trailing newlines).  Given that most
581         # (all?) terminals in common use are related to ECMA-48, this
582         # shouldn't be a problem.
583         say_color_error=$(tput bold; tput setaf 1) # bold red
584         say_color_skip=$(tput setaf 4) # blue
585         say_color_warn=$(tput setaf 3) # brown/yellow
586         say_color_pass=$(tput setaf 2) # green
587         say_color_info=$(tput setaf 6) # cyan
588         say_color_reset=$(tput sgr0)
589         say_color_="" # no formatting for normal text
590         say_color () {
591                 test -z "$1" && test -n "$quiet" && return
592                 eval "say_color_color=\$say_color_$1"
593                 shift
594                 printf "%s\\n" "$say_color_color$*$say_color_reset"
595         }
596 else
597         say_color() {
598                 test -z "$1" && test -n "$quiet" && return
599                 shift
600                 printf "%s\n" "$*"
601         }
602 fi
603
604 TERM=dumb
605 export TERM
606
607 error () {
608         say_color error "error: $*"
609         finalize_junit_xml
610         GIT_EXIT_OK=t
611         exit 1
612 }
613
614 BUG () {
615         error >&7 "bug in the test script: $*"
616 }
617
618 say () {
619         say_color info "$*"
620 }
621
622 if test -n "$HARNESS_ACTIVE"
623 then
624         if test "$verbose" = t || test -n "$verbose_only"
625         then
626                 printf 'Bail out! %s\n' \
627                  'verbose mode forbidden under TAP harness; try --verbose-log'
628                 exit 1
629         fi
630 fi
631
632 test "${test_description}" != "" ||
633 error "Test script did not set test_description."
634
635 if test "$help" = "t"
636 then
637         printf '%s\n' "$test_description"
638         exit 0
639 fi
640
641 exec 5>&1
642 exec 6<&0
643 exec 7>&2
644 if test "$verbose_log" = "t"
645 then
646         exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
647 elif test "$verbose" = "t"
648 then
649         exec 4>&2 3>&1
650 else
651         exec 4>/dev/null 3>/dev/null
652 fi
653
654 # Send any "-x" output directly to stderr to avoid polluting tests
655 # which capture stderr. We can do this unconditionally since it
656 # has no effect if tracing isn't turned on.
657 #
658 # Note that this sets up the trace fd as soon as we assign the variable, so it
659 # must come after the creation of descriptor 4 above. Likewise, we must never
660 # unset this, as it has the side effect of closing descriptor 4, which we
661 # use to show verbose tests to the user.
662 #
663 # Note also that we don't need or want to export it. The tracing is local to
664 # this shell, and we would not want to influence any shells we exec.
665 BASH_XTRACEFD=4
666
667 test_failure=0
668 test_count=0
669 test_fixed=0
670 test_broken=0
671 test_success=0
672
673 test_external_has_tap=0
674
675 die () {
676         code=$?
677         # This is responsible for running the atexit commands even when a
678         # test script run with '--immediate' fails, or when the user hits
679         # ctrl-C, i.e. when 'test_done' is not invoked at all.
680         test_atexit_handler || code=$?
681         if test -n "$GIT_EXIT_OK"
682         then
683                 exit $code
684         else
685                 echo >&5 "FATAL: Unexpected exit with code $code"
686                 exit 1
687         fi
688 }
689
690 GIT_EXIT_OK=
691 trap 'die' EXIT
692 # Disable '-x' tracing, because with some shells, notably dash, it
693 # prevents running the cleanup commands when a test script run with
694 # '--verbose-log -x' is interrupted.
695 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
696
697 # The user-facing functions are loaded from a separate file so that
698 # test_perf subshells can have them too
699 . "$TEST_DIRECTORY/test-lib-functions.sh"
700
701 # You are not expected to call test_ok_ and test_failure_ directly, use
702 # the test_expect_* functions instead.
703
704 test_ok_ () {
705         if test -n "$write_junit_xml"
706         then
707                 write_junit_xml_testcase "$*"
708         fi
709         test_success=$(($test_success + 1))
710         say_color "" "ok $test_count - $@"
711 }
712
713 test_failure_ () {
714         if test -n "$write_junit_xml"
715         then
716                 junit_insert="<failure message=\"not ok $test_count -"
717                 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
718                 junit_insert="$junit_insert $(xml_attr_encode \
719                         "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
720                            then
721                                 test-tool path-utils skip-n-bytes \
722                                         "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
723                            else
724                                 printf '%s\n' "$@" | sed 1d
725                            fi)")"
726                 junit_insert="$junit_insert</failure>"
727                 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
728                 then
729                         junit_insert="$junit_insert<system-err>$(xml_attr_encode \
730                                 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
731                 fi
732                 write_junit_xml_testcase "$1" "      $junit_insert"
733         fi
734         test_failure=$(($test_failure + 1))
735         say_color error "not ok $test_count - $1"
736         shift
737         printf '%s\n' "$*" | sed -e 's/^/#      /'
738         test "$immediate" = "" || { finalize_junit_xml; GIT_EXIT_OK=t; exit 1; }
739 }
740
741 test_known_broken_ok_ () {
742         if test -n "$write_junit_xml"
743         then
744                 write_junit_xml_testcase "$* (breakage fixed)"
745         fi
746         test_fixed=$(($test_fixed+1))
747         say_color error "ok $test_count - $@ # TODO known breakage vanished"
748 }
749
750 test_known_broken_failure_ () {
751         if test -n "$write_junit_xml"
752         then
753                 write_junit_xml_testcase "$* (known breakage)"
754         fi
755         test_broken=$(($test_broken+1))
756         say_color warn "not ok $test_count - $@ # TODO known breakage"
757 }
758
759 test_debug () {
760         test "$debug" = "" || eval "$1"
761 }
762
763 match_pattern_list () {
764         arg="$1"
765         shift
766         test -z "$*" && return 1
767         for pattern_
768         do
769                 case "$arg" in
770                 $pattern_)
771                         return 0
772                 esac
773         done
774         return 1
775 }
776
777 match_test_selector_list () {
778         operation="$1"
779         shift
780         title="$1"
781         shift
782         arg="$1"
783         shift
784         test -z "$1" && return 0
785
786         # Commas are accepted as separators.
787         OLDIFS=$IFS
788         IFS=','
789         set -- $1
790         IFS=$OLDIFS
791
792         # If the first selector is negative we include by default.
793         include=
794         case "$1" in
795                 !*) include=t ;;
796         esac
797
798         for selector
799         do
800                 orig_selector=$selector
801
802                 positive=t
803                 case "$selector" in
804                         !*)
805                                 positive=
806                                 selector=${selector##?}
807                                 ;;
808                 esac
809
810                 test -z "$selector" && continue
811
812                 case "$selector" in
813                         *-*)
814                                 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
815                                 then
816                                         echo "error: $operation: invalid non-numeric in range" \
817                                                 "start: '$orig_selector'" >&2
818                                         exit 1
819                                 fi
820                                 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
821                                 then
822                                         echo "error: $operation: invalid non-numeric in range" \
823                                                 "end: '$orig_selector'" >&2
824                                         exit 1
825                                 fi
826                                 ;;
827                         *)
828                                 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
829                                 then
830                                         case "$title" in *${selector}*)
831                                                 include=$positive
832                                                 ;;
833                                         esac
834                                         continue
835                                 fi
836                 esac
837
838                 # Short cut for "obvious" cases
839                 test -z "$include" && test -z "$positive" && continue
840                 test -n "$include" && test -n "$positive" && continue
841
842                 case "$selector" in
843                         -*)
844                                 if test $arg -le ${selector#-}
845                                 then
846                                         include=$positive
847                                 fi
848                                 ;;
849                         *-)
850                                 if test $arg -ge ${selector%-}
851                                 then
852                                         include=$positive
853                                 fi
854                                 ;;
855                         *-*)
856                                 if test ${selector%%-*} -le $arg \
857                                         && test $arg -le ${selector#*-}
858                                 then
859                                         include=$positive
860                                 fi
861                                 ;;
862                         *)
863                                 if test $arg -eq $selector
864                                 then
865                                         include=$positive
866                                 fi
867                                 ;;
868                 esac
869         done
870
871         test -n "$include"
872 }
873
874 maybe_teardown_verbose () {
875         test -z "$verbose_only" && return
876         exec 4>/dev/null 3>/dev/null
877         verbose=
878 }
879
880 last_verbose=t
881 maybe_setup_verbose () {
882         test -z "$verbose_only" && return
883         if match_pattern_list $test_count $verbose_only
884         then
885                 exec 4>&2 3>&1
886                 # Emit a delimiting blank line when going from
887                 # non-verbose to verbose.  Within verbose mode the
888                 # delimiter is printed by test_expect_*.  The choice
889                 # of the initial $last_verbose is such that before
890                 # test 1, we do not print it.
891                 test -z "$last_verbose" && echo >&3 ""
892                 verbose=t
893         else
894                 exec 4>/dev/null 3>/dev/null
895                 verbose=
896         fi
897         last_verbose=$verbose
898 }
899
900 maybe_teardown_valgrind () {
901         test -z "$GIT_VALGRIND" && return
902         GIT_VALGRIND_ENABLED=
903 }
904
905 maybe_setup_valgrind () {
906         test -z "$GIT_VALGRIND" && return
907         if test -z "$valgrind_only"
908         then
909                 GIT_VALGRIND_ENABLED=t
910                 return
911         fi
912         GIT_VALGRIND_ENABLED=
913         if match_pattern_list $test_count $valgrind_only
914         then
915                 GIT_VALGRIND_ENABLED=t
916         fi
917 }
918
919 trace_level_=0
920 want_trace () {
921         test "$trace" = t && {
922                 test "$verbose" = t || test "$verbose_log" = t
923         }
924 }
925
926 # This is a separate function because some tests use
927 # "return" to end a test_expect_success block early
928 # (and we want to make sure we run any cleanup like
929 # "set +x").
930 test_eval_inner_ () {
931         # Do not add anything extra (including LF) after '$*'
932         eval "
933                 want_trace && trace_level_=$(($trace_level_+1)) && set -x
934                 $*"
935 }
936
937 test_eval_ () {
938         # If "-x" tracing is in effect, then we want to avoid polluting stderr
939         # with non-test commands. But once in "set -x" mode, we cannot prevent
940         # the shell from printing the "set +x" to turn it off (nor the saving
941         # of $? before that). But we can make sure that the output goes to
942         # /dev/null.
943         #
944         # There are a few subtleties here:
945         #
946         #   - we have to redirect descriptor 4 in addition to 2, to cover
947         #     BASH_XTRACEFD
948         #
949         #   - the actual eval has to come before the redirection block (since
950         #     it needs to see descriptor 4 to set up its stderr)
951         #
952         #   - likewise, any error message we print must be outside the block to
953         #     access descriptor 4
954         #
955         #   - checking $? has to come immediately after the eval, but it must
956         #     be _inside_ the block to avoid polluting the "set -x" output
957         #
958
959         test_eval_inner_ "$@" </dev/null >&3 2>&4
960         {
961                 test_eval_ret_=$?
962                 if want_trace
963                 then
964                         test 1 = $trace_level_ && set +x
965                         trace_level_=$(($trace_level_-1))
966                 fi
967         } 2>/dev/null 4>&2
968
969         if test "$test_eval_ret_" != 0 && want_trace
970         then
971                 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
972         fi
973         return $test_eval_ret_
974 }
975
976 test_run_ () {
977         test_cleanup=:
978         expecting_failure=$2
979
980         if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
981                 # turn off tracing for this test-eval, as it simply creates
982                 # confusing noise in the "-x" output
983                 trace_tmp=$trace
984                 trace=
985                 # 117 is magic because it is unlikely to match the exit
986                 # code of other programs
987                 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
988                         test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
989                 then
990                         BUG "broken &&-chain or run-away HERE-DOC: $1"
991                 fi
992                 trace=$trace_tmp
993         fi
994
995         setup_malloc_check
996         test_eval_ "$1"
997         eval_ret=$?
998         teardown_malloc_check
999
1000         if test -z "$immediate" || test $eval_ret = 0 ||
1001            test -n "$expecting_failure" && test "$test_cleanup" != ":"
1002         then
1003                 setup_malloc_check
1004                 test_eval_ "$test_cleanup"
1005                 teardown_malloc_check
1006         fi
1007         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1008         then
1009                 echo ""
1010         fi
1011         return "$eval_ret"
1012 }
1013
1014 test_start_ () {
1015         test_count=$(($test_count+1))
1016         maybe_setup_verbose
1017         maybe_setup_valgrind
1018         if test -n "$write_junit_xml"
1019         then
1020                 junit_start=$(test-tool date getnanos)
1021         fi
1022 }
1023
1024 test_finish_ () {
1025         echo >&3 ""
1026         maybe_teardown_valgrind
1027         maybe_teardown_verbose
1028         if test -n "$GIT_TEST_TEE_OFFSET"
1029         then
1030                 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1031                         "$GIT_TEST_TEE_OUTPUT_FILE")
1032         fi
1033 }
1034
1035 test_skip () {
1036         to_skip=
1037         skipped_reason=
1038         if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
1039         then
1040                 to_skip=t
1041                 skipped_reason="GIT_SKIP_TESTS"
1042         fi
1043         if test -z "$to_skip" && test -n "$run_list" &&
1044            ! match_test_selector_list '--run' "$1" $test_count "$run_list"
1045         then
1046                 to_skip=t
1047                 skipped_reason="--run"
1048         fi
1049         if test -z "$to_skip" && test -n "$test_prereq" &&
1050            ! test_have_prereq "$test_prereq"
1051         then
1052                 to_skip=t
1053
1054                 of_prereq=
1055                 if test "$missing_prereq" != "$test_prereq"
1056                 then
1057                         of_prereq=" of $test_prereq"
1058                 fi
1059                 skipped_reason="missing $missing_prereq${of_prereq}"
1060         fi
1061
1062         case "$to_skip" in
1063         t)
1064                 if test -n "$write_junit_xml"
1065                 then
1066                         message="$(xml_attr_encode "$skipped_reason")"
1067                         write_junit_xml_testcase "$1" \
1068                                 "      <skipped message=\"$message\" />"
1069                 fi
1070
1071                 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1072                 : true
1073                 ;;
1074         *)
1075                 false
1076                 ;;
1077         esac
1078 }
1079
1080 # stub; perf-lib overrides it
1081 test_at_end_hook_ () {
1082         :
1083 }
1084
1085 write_junit_xml () {
1086         case "$1" in
1087         --truncate)
1088                 >"$junit_xml_path"
1089                 junit_have_testcase=
1090                 shift
1091                 ;;
1092         esac
1093         printf '%s\n' "$@" >>"$junit_xml_path"
1094 }
1095
1096 xml_attr_encode () {
1097         printf '%s\n' "$@" | test-tool xml-encode
1098 }
1099
1100 write_junit_xml_testcase () {
1101         junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1102         shift
1103         junit_attrs="$junit_attrs classname=\"$this_test\""
1104         junit_attrs="$junit_attrs time=\"$(test-tool \
1105                 date getnanos $junit_start)\""
1106         write_junit_xml "$(printf '%s\n' \
1107                 "    <testcase $junit_attrs>" "$@" "    </testcase>")"
1108         junit_have_testcase=t
1109 }
1110
1111 finalize_junit_xml () {
1112         if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1113         then
1114                 test -n "$junit_have_testcase" || {
1115                         junit_start=$(test-tool date getnanos)
1116                         write_junit_xml_testcase "all tests skipped"
1117                 }
1118
1119                 # adjust the overall time
1120                 junit_time=$(test-tool date getnanos $junit_suite_start)
1121                 sed -e "s/\(<testsuite.*\) time=\"[^\"]*\"/\1/" \
1122                         -e "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1123                         -e '/^ *<\/testsuite/d' \
1124                         <"$junit_xml_path" >"$junit_xml_path.new"
1125                 mv "$junit_xml_path.new" "$junit_xml_path"
1126
1127                 write_junit_xml "  </testsuite>" "</testsuites>"
1128                 write_junit_xml=
1129         fi
1130 }
1131
1132 test_atexit_cleanup=:
1133 test_atexit_handler () {
1134         # In a succeeding test script 'test_atexit_handler' is invoked
1135         # twice: first from 'test_done', then from 'die' in the trap on
1136         # EXIT.
1137         # This condition and resetting 'test_atexit_cleanup' below makes
1138         # sure that the registered cleanup commands are run only once.
1139         test : != "$test_atexit_cleanup" || return 0
1140
1141         setup_malloc_check
1142         test_eval_ "$test_atexit_cleanup"
1143         test_atexit_cleanup=:
1144         teardown_malloc_check
1145 }
1146
1147 test_done () {
1148         GIT_EXIT_OK=t
1149
1150         # Run the atexit commands _before_ the trash directory is
1151         # removed, so the commands can access pidfiles and socket files.
1152         test_atexit_handler
1153
1154         finalize_junit_xml
1155
1156         if test -z "$HARNESS_ACTIVE"
1157         then
1158                 mkdir -p "$TEST_RESULTS_DIR"
1159
1160                 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1161                 total $test_count
1162                 success $test_success
1163                 fixed $test_fixed
1164                 broken $test_broken
1165                 failed $test_failure
1166
1167                 EOF
1168         fi
1169
1170         if test "$test_fixed" != 0
1171         then
1172                 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1173         fi
1174         if test "$test_broken" != 0
1175         then
1176                 say_color warn "# still have $test_broken known breakage(s)"
1177         fi
1178         if test "$test_broken" != 0 || test "$test_fixed" != 0
1179         then
1180                 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1181                 msg="remaining $test_remaining test(s)"
1182         else
1183                 test_remaining=$test_count
1184                 msg="$test_count test(s)"
1185         fi
1186         case "$test_failure" in
1187         0)
1188                 if test $test_external_has_tap -eq 0
1189                 then
1190                         if test $test_remaining -gt 0
1191                         then
1192                                 say_color pass "# passed all $msg"
1193                         fi
1194
1195                         # Maybe print SKIP message
1196                         test -z "$skip_all" || skip_all="# SKIP $skip_all"
1197                         case "$test_count" in
1198                         0)
1199                                 say "1..$test_count${skip_all:+ $skip_all}"
1200                                 ;;
1201                         *)
1202                                 test -z "$skip_all" ||
1203                                 say_color warn "$skip_all"
1204                                 say "1..$test_count"
1205                                 ;;
1206                         esac
1207                 fi
1208
1209                 if test -z "$debug"
1210                 then
1211                         test -d "$TRASH_DIRECTORY" ||
1212                         error "Tests passed but trash directory already removed before test cleanup; aborting"
1213
1214                         cd "$TRASH_DIRECTORY/.." &&
1215                         rm -fr "$TRASH_DIRECTORY" || {
1216                                 # try again in a bit
1217                                 sleep 5;
1218                                 rm -fr "$TRASH_DIRECTORY"
1219                         } ||
1220                         error "Tests passed but test cleanup failed; aborting"
1221                 fi
1222                 test_at_end_hook_
1223
1224                 exit 0 ;;
1225
1226         *)
1227                 if test $test_external_has_tap -eq 0
1228                 then
1229                         say_color error "# failed $test_failure among $msg"
1230                         say "1..$test_count"
1231                 fi
1232
1233                 exit 1 ;;
1234
1235         esac
1236 }
1237
1238 if test -n "$valgrind"
1239 then
1240         make_symlink () {
1241                 test -h "$2" &&
1242                 test "$1" = "$(readlink "$2")" || {
1243                         # be super paranoid
1244                         if mkdir "$2".lock
1245                         then
1246                                 rm -f "$2" &&
1247                                 ln -s "$1" "$2" &&
1248                                 rm -r "$2".lock
1249                         else
1250                                 while test -d "$2".lock
1251                                 do
1252                                         say "Waiting for lock on $2."
1253                                         sleep 1
1254                                 done
1255                         fi
1256                 }
1257         }
1258
1259         make_valgrind_symlink () {
1260                 # handle only executables, unless they are shell libraries that
1261                 # need to be in the exec-path.
1262                 test -x "$1" ||
1263                 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1264                 return;
1265
1266                 base=$(basename "$1")
1267                 case "$base" in
1268                 test-*)
1269                         symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1270                         ;;
1271                 *)
1272                         symlink_target="$GIT_BUILD_DIR/$base"
1273                         ;;
1274                 esac
1275                 # do not override scripts
1276                 if test -x "$symlink_target" &&
1277                     test ! -d "$symlink_target" &&
1278                     test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1279                 then
1280                         symlink_target=../valgrind.sh
1281                 fi
1282                 case "$base" in
1283                 *.sh|*.perl)
1284                         symlink_target=../unprocessed-script
1285                 esac
1286                 # create the link, or replace it if it is out of date
1287                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1288         }
1289
1290         # override all git executables in TEST_DIRECTORY/..
1291         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1292         mkdir -p "$GIT_VALGRIND"/bin
1293         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1294         do
1295                 make_valgrind_symlink $file
1296         done
1297         # special-case the mergetools loadables
1298         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1299         OLDIFS=$IFS
1300         IFS=:
1301         for path in $PATH
1302         do
1303                 ls "$path"/git-* 2> /dev/null |
1304                 while read file
1305                 do
1306                         make_valgrind_symlink "$file"
1307                 done
1308         done
1309         IFS=$OLDIFS
1310         PATH=$GIT_VALGRIND/bin:$PATH
1311         GIT_EXEC_PATH=$GIT_VALGRIND/bin
1312         export GIT_VALGRIND
1313         GIT_VALGRIND_MODE="$valgrind"
1314         export GIT_VALGRIND_MODE
1315         GIT_VALGRIND_ENABLED=t
1316         test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1317         export GIT_VALGRIND_ENABLED
1318 elif test -n "$GIT_TEST_INSTALLED"
1319 then
1320         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
1321         error "Cannot run git from $GIT_TEST_INSTALLED."
1322         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1323         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1324 else # normal case, use ../bin-wrappers only unless $with_dashes:
1325         if test -n "$no_bin_wrappers"
1326         then
1327                 with_dashes=t
1328         else
1329                 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1330                 if ! test -x "$git_bin_dir/git"
1331                 then
1332                         if test -z "$with_dashes"
1333                         then
1334                                 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1335                         fi
1336                         with_dashes=t
1337                 fi
1338                 PATH="$git_bin_dir:$PATH"
1339         fi
1340         GIT_EXEC_PATH=$GIT_BUILD_DIR
1341         if test -n "$with_dashes"
1342         then
1343                 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1344         fi
1345 fi
1346 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1347 GIT_CONFIG_NOSYSTEM=1
1348 GIT_ATTR_NOSYSTEM=1
1349 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1350
1351 if test -z "$GIT_TEST_CMP"
1352 then
1353         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1354         then
1355                 GIT_TEST_CMP="$DIFF -c"
1356         else
1357                 GIT_TEST_CMP="$DIFF -u"
1358         fi
1359 fi
1360
1361 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1362 export GITPERLLIB
1363 test -d "$GIT_BUILD_DIR"/templates/blt || {
1364         error "You haven't built things yet, have you?"
1365 }
1366
1367 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1368 then
1369         echo >&2 'You need to build test-tool:'
1370         echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1371         exit 1
1372 fi
1373
1374 # Test repository
1375 rm -fr "$TRASH_DIRECTORY" || {
1376         GIT_EXIT_OK=t
1377         echo >&5 "FATAL: Cannot prepare test area"
1378         exit 1
1379 }
1380
1381 HOME="$TRASH_DIRECTORY"
1382 GNUPGHOME="$HOME/gnupg-home-not-used"
1383 export HOME GNUPGHOME
1384
1385 if test -z "$TEST_NO_CREATE_REPO"
1386 then
1387         test_create_repo "$TRASH_DIRECTORY"
1388 else
1389         mkdir -p "$TRASH_DIRECTORY"
1390 fi
1391
1392 # Use -P to resolve symlinks in our working directory so that the cwd
1393 # in subprocesses like git equals our $PWD (for pathname comparisons).
1394 cd -P "$TRASH_DIRECTORY" || exit 1
1395
1396 this_test=${0##*/}
1397 this_test=${this_test%%-*}
1398 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1399 then
1400         say_color info >&3 "skipping test $this_test altogether"
1401         skip_all="skip all tests in $this_test"
1402         test_done
1403 fi
1404
1405 if test -n "$write_junit_xml"
1406 then
1407         junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1408         mkdir -p "$junit_xml_dir"
1409         junit_xml_base=${0##*/}
1410         junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1411         junit_attrs="name=\"${junit_xml_base%.sh}\""
1412         junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1413                 date +%Y-%m-%dT%H:%M:%S)\""
1414         write_junit_xml --truncate "<testsuites>" "  <testsuite $junit_attrs>"
1415         junit_suite_start=$(test-tool date getnanos)
1416         if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1417         then
1418                 GIT_TEST_TEE_OFFSET=0
1419         fi
1420 fi
1421
1422 # Convenience
1423 # A regexp to match 5, 35 and 40 hexdigits
1424 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1425 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1426 _x40="$_x35$_x05"
1427
1428 test_oid_init
1429
1430 ZERO_OID=$(test_oid zero)
1431 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1432 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1433 EMPTY_TREE=$(test_oid empty_tree)
1434 EMPTY_BLOB=$(test_oid empty_blob)
1435 _z40=$ZERO_OID
1436
1437 # Provide an implementation of the 'yes' utility; the upper bound
1438 # limit is there to help Windows that cannot stop this loop from
1439 # wasting cycles when the downstream stops reading, so do not be
1440 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1441 # limit the output of the yes utility", 2016-02-02)
1442 yes () {
1443         if test $# = 0
1444         then
1445                 y=y
1446         else
1447                 y="$*"
1448         fi
1449
1450         i=0
1451         while test $i -lt 99
1452         do
1453                 echo "$y"
1454                 i=$(($i+1))
1455         done
1456 }
1457
1458 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1459 # thus needs to be set up really early, and set an internal variable
1460 # for convenience so the hot test_set_prereq() codepath doesn't need
1461 # to call "git env--helper" (via test_bool_env). Only do that work
1462 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1463 GIT_TEST_FAIL_PREREQS_INTERNAL=
1464 if test -n "$GIT_TEST_FAIL_PREREQS"
1465 then
1466         if test_bool_env GIT_TEST_FAIL_PREREQS false
1467         then
1468                 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1469                 test_set_prereq FAIL_PREREQS
1470         fi
1471 else
1472         test_lazy_prereq FAIL_PREREQS '
1473                 test_bool_env GIT_TEST_FAIL_PREREQS false
1474         '
1475 fi
1476
1477 # Fix some commands on Windows, and other OS-specific things
1478 uname_s=$(uname -s)
1479 case $uname_s in
1480 *MINGW*)
1481         # Windows has its own (incompatible) sort and find
1482         sort () {
1483                 /usr/bin/sort "$@"
1484         }
1485         find () {
1486                 /usr/bin/find "$@"
1487         }
1488         # git sees Windows-style pwd
1489         pwd () {
1490                 builtin pwd -W
1491         }
1492         # no POSIX permissions
1493         # backslashes in pathspec are converted to '/'
1494         # exec does not inherit the PID
1495         test_set_prereq MINGW
1496         test_set_prereq NATIVE_CRLF
1497         test_set_prereq SED_STRIPS_CR
1498         test_set_prereq GREP_STRIPS_CR
1499         GIT_TEST_CMP=mingw_test_cmp
1500         ;;
1501 *CYGWIN*)
1502         test_set_prereq POSIXPERM
1503         test_set_prereq EXECKEEPSPID
1504         test_set_prereq CYGWIN
1505         test_set_prereq SED_STRIPS_CR
1506         test_set_prereq GREP_STRIPS_CR
1507         ;;
1508 *)
1509         test_set_prereq POSIXPERM
1510         test_set_prereq BSLASHPSPEC
1511         test_set_prereq EXECKEEPSPID
1512         ;;
1513 esac
1514
1515 # Detect arches where a few things don't work
1516 uname_m=$(uname -m)
1517 case $uname_m in
1518 parisc* | hppa*)
1519         test_set_prereq HPPA
1520         ;;
1521 esac
1522
1523 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1524 test -z "$NO_PERL" && test_set_prereq PERL
1525 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1526 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1527 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1528 test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1529 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1530 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1531
1532 if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1533 then
1534         GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1535         export GIT_TEST_GETTEXT_POISON
1536         unset GIT_TEST_GETTEXT_POISON_ORIG
1537 fi
1538
1539 test_lazy_prereq C_LOCALE_OUTPUT '
1540         ! test_bool_env GIT_TEST_GETTEXT_POISON false
1541 '
1542
1543 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1544 then
1545         GIT_TEST_CHECK_CACHE_TREE=true
1546         export GIT_TEST_CHECK_CACHE_TREE
1547 fi
1548
1549 test_lazy_prereq PIPE '
1550         # test whether the filesystem supports FIFOs
1551         test_have_prereq !MINGW,!CYGWIN &&
1552         rm -f testfifo && mkfifo testfifo
1553 '
1554
1555 test_lazy_prereq SYMLINKS '
1556         # test whether the filesystem supports symbolic links
1557         ln -s x y && test -h y
1558 '
1559
1560 test_lazy_prereq FILEMODE '
1561         test "$(git config --bool core.filemode)" = true
1562 '
1563
1564 test_lazy_prereq CASE_INSENSITIVE_FS '
1565         echo good >CamelCase &&
1566         echo bad >camelcase &&
1567         test "$(cat CamelCase)" != good
1568 '
1569
1570 test_lazy_prereq FUNNYNAMES '
1571         test_have_prereq !MINGW &&
1572         touch -- \
1573                 "FUNNYNAMES tab embedded" \
1574                 "FUNNYNAMES \"quote embedded\"" \
1575                 "FUNNYNAMES newline
1576 embedded" 2>/dev/null &&
1577         rm -- \
1578                 "FUNNYNAMES tab embedded" \
1579                 "FUNNYNAMES \"quote embedded\"" \
1580                 "FUNNYNAMES newline
1581 embedded" 2>/dev/null
1582 '
1583
1584 test_lazy_prereq UTF8_NFD_TO_NFC '
1585         # check whether FS converts nfd unicode to nfc
1586         auml=$(printf "\303\244")
1587         aumlcdiar=$(printf "\141\314\210")
1588         >"$auml" &&
1589         test -f "$aumlcdiar"
1590 '
1591
1592 test_lazy_prereq AUTOIDENT '
1593         sane_unset GIT_AUTHOR_NAME &&
1594         sane_unset GIT_AUTHOR_EMAIL &&
1595         git var GIT_AUTHOR_IDENT
1596 '
1597
1598 test_lazy_prereq EXPENSIVE '
1599         test -n "$GIT_TEST_LONG"
1600 '
1601
1602 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1603         test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1604 '
1605
1606 test_lazy_prereq USR_BIN_TIME '
1607         test -x /usr/bin/time
1608 '
1609
1610 test_lazy_prereq NOT_ROOT '
1611         uid=$(id -u) &&
1612         test "$uid" != 0
1613 '
1614
1615 test_lazy_prereq JGIT '
1616         jgit --version
1617 '
1618
1619 # SANITY is about "can you correctly predict what the filesystem would
1620 # do by only looking at the permission bits of the files and
1621 # directories?"  A typical example of !SANITY is running the test
1622 # suite as root, where a test may expect "chmod -r file && cat file"
1623 # to fail because file is supposed to be unreadable after a successful
1624 # chmod.  In an environment (i.e. combination of what filesystem is
1625 # being used and who is running the tests) that lacks SANITY, you may
1626 # be able to delete or create a file when the containing directory
1627 # doesn't have write permissions, or access a file even if the
1628 # containing directory doesn't have read or execute permissions.
1629
1630 test_lazy_prereq SANITY '
1631         mkdir SANETESTD.1 SANETESTD.2 &&
1632
1633         chmod +w SANETESTD.1 SANETESTD.2 &&
1634         >SANETESTD.1/x 2>SANETESTD.2/x &&
1635         chmod -w SANETESTD.1 &&
1636         chmod -r SANETESTD.1/x &&
1637         chmod -rx SANETESTD.2 ||
1638         BUG "cannot prepare SANETESTD"
1639
1640         ! test -r SANETESTD.1/x &&
1641         ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1642         status=$?
1643
1644         chmod +rwx SANETESTD.1 SANETESTD.2 &&
1645         rm -rf SANETESTD.1 SANETESTD.2 ||
1646         BUG "cannot clean SANETESTD"
1647         return $status
1648 '
1649
1650 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1651 GIT_UNZIP=${GIT_UNZIP:-unzip}
1652 test_lazy_prereq UNZIP '
1653         "$GIT_UNZIP" -v
1654         test $? -ne 127
1655 '
1656
1657 run_with_limited_cmdline () {
1658         (ulimit -s 128 && "$@")
1659 }
1660
1661 test_lazy_prereq CMDLINE_LIMIT '
1662         test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1663         run_with_limited_cmdline true
1664 '
1665
1666 run_with_limited_stack () {
1667         (ulimit -s 128 && "$@")
1668 }
1669
1670 test_lazy_prereq ULIMIT_STACK_SIZE '
1671         test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1672         run_with_limited_stack true
1673 '
1674
1675 run_with_limited_open_files () {
1676         (ulimit -n 32 && "$@")
1677 }
1678
1679 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1680         test_have_prereq !MINGW,!CYGWIN &&
1681         run_with_limited_open_files true
1682 '
1683
1684 build_option () {
1685         git version --build-options |
1686         sed -ne "s/^$1: //p"
1687 }
1688
1689 test_lazy_prereq LONG_IS_64BIT '
1690         test 8 -le "$(build_option sizeof-long)"
1691 '
1692
1693 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1694 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1695
1696 test_lazy_prereq CURL '
1697         curl --version
1698 '
1699
1700 # SHA1 is a test if the hash algorithm in use is SHA-1.  This is both for tests
1701 # which will not work with other hash algorithms and tests that work but don't
1702 # test anything meaningful (e.g. special values which cause short collisions).
1703 test_lazy_prereq SHA1 '
1704         case "$GIT_DEFAULT_HASH" in
1705         sha1) true ;;
1706         "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1707         *) false ;;
1708         esac
1709 '
1710
1711 test_lazy_prereq REBASE_P '
1712         test -z "$GIT_TEST_SKIP_REBASE_P"
1713 '
1714
1715 # Special-purpose prereq for transitioning to a new default branch name:
1716 # Some tests need more than just a mindless (case-preserving) s/master/main/g
1717 # replacement. The non-trivial adjustments are guarded behind this
1718 # prerequisite, acting kind of as a feature flag
1719 test_lazy_prereq PREPARE_FOR_MAIN_BRANCH '
1720         test "$GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME" = main
1721 '
1722
1723 # Ensure that no test accidentally triggers a Git command
1724 # that runs 'crontab', affecting a user's cron schedule.
1725 # Tests that verify the cron integration must set this locally
1726 # to avoid errors.
1727 GIT_TEST_CRONTAB="exit 1"